import { Directive, ElementRef, Renderer2, Input, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Blink {
    constructor() {
        this.keyframes = [
            { transform: 'scale(1)' },
            { transform: 'scale(0.93)' },
            { transform: 'scale(0.95)' },
            { transform: 'scale(0.91)' },
            { transform: 'scale(1)' }
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Blink.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Bounce {
    constructor() {
        this.keyframes = [
            { transform: 'translate(0, 0)' },
            { transform: 'translate(0, 3px)' },
            { transform: 'translate(0, -6px)' },
            { transform: 'translate(0, 3px)' },
            { transform: 'translate(0, 0)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Bounce.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const defaultDuration = 2000;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Fade {
    constructor() {
        this.keyframes = [
            { opacity: '1' },
            { opacity: '0.6' },
            { opacity: '0.8' },
            { opacity: '1' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Fade.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Flicker {
    constructor() {
        this.keyframes = [
            { transform: 'skewX(0deg)' },
            { transform: 'skewX(10deg)' },
            { transform: 'skewX(-10deg)' },
            { transform: 'skewX(5deg)' },
            { transform: 'skewX(-5deg)' },
            { transform: 'skewX(0deg)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Flicker.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Groove {
    constructor() {
        this.keyframes = [
            { transform: 'skewY(0deg) rotate(0deg)' },
            { transform: 'skewY(-10deg) rotateZ(8deg)' },
            { transform: 'skewY(10deg) rotateZ(-8deg)' },
            { transform: 'skewY(6deg) rotateZ(4deg)' },
            { transform: 'skewY(0deg) rotate(0deg)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Groove.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Jelly {
    constructor() {
        this.keyframes = [
            { transform: 'scaleX(1)' },
            { transform: 'scaleX(0.9)' },
            { transform: 'scaleX(1.25)' },
            { transform: 'scaleX(0.8)' },
            { transform: 'scaleX(1)' }
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Jelly.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Jerk {
    constructor() {
        this.keyframes = [
            { transform: 'translateX(0px) rotateZ(0deg)' },
            { transform: 'translateX(-5px) rotateZ(-15deg)' },
            { transform: 'translateX(5px) rotateZ(15deg)' },
            { transform: 'translateX(-3px) rotateZ(5deg)' },
            { transform: 'translateX(3px) rotateZ(-5deg)' },
            { transform: 'translateX(0px) rotateZ(0deg)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Jerk.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Pop {
    constructor() {
        this.keyframes = [
            { transform: 'scaleX(1) scaleY(1)' },
            { transform: 'scaleX(1.35) scaleY(0.1)' },
            { transform: 'scaleX(0.8) scaleY(1.7)' },
            { transform: 'scaleX(0.6) scaleY(0.85)' },
            { transform: 'scaleX(1) scaleY(1)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Pop.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Shake {
    constructor() {
        this.keyframes = [
            { transform: 'translateX(0px)' },
            { transform: 'translateX(-3px)' },
            { transform: 'translateX(3px)' },
            { transform: 'translateX(-2px)' },
            { transform: 'translateX(3px)' },
            { transform: 'translateX(-2px)' },
            { transform: 'translateX(0px)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Shake.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Squeeze {
    constructor() {
        this.keyframes = [
            { transform: 'scaleY(1)' },
            { transform: 'scaleY(0.95)' },
            { transform: 'scaleY(0.9)' },
            { transform: 'scaleY(0.75)' },
            { transform: 'scaleY(1.3)' },
            { transform: 'scaleY(0.95)' },
            { transform: 'scaleY(1)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Squeeze.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Swing {
    constructor() {
        this.keyframes = [
            { transform: 'rotateZ(0deg)' },
            { transform: 'rotateZ(15deg)' },
            { transform: 'rotateZ(-15deg)' },
            { transform: 'rotateZ(7deg)' },
            { transform: 'rotateZ(-7deg)' },
            { transform: 'rotateZ(0deg)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Swing.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Tada {
    constructor() {
        this.keyframes = [
            { transform: 'scale(1)' },
            { transform: 'scale(1.1) rotate(3deg)' },
            { transform: 'scale(0.97)' },
            { transform: 'scale(0.99) rotate(-3deg)' },
            { transform: 'scale(1.05)' },
            { transform: 'scale(1)' },
        ];
    }
    /**
     * @param {?} elementRef
     * @param {?} __1
     * @return {?}
     */
    start(elementRef, { duration }) {
        elementRef.nativeElement.animate(this.keyframes, { duration });
    }
}
if (false) {
    /** @type {?} */
    Tada.prototype.keyframes;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const INTERACTION_TYPES = {
    blink: Blink,
    bounce: Bounce,
    fade: Fade,
    flicker: Flicker,
    groove: Groove,
    jelly: Jelly,
    jerk: Jerk,
    pop: Pop,
    shake: Shake,
    squeeze: Squeeze,
    swing: Swing,
    tada: Tada
};
class NgMicroInteractFactory {
    /**
     * @param {?} type
     * @param {?} element
     * @param {?} options
     * @return {?}
     */
    static setInteraction(type, element, options) {
        return new INTERACTION_TYPES[type]()
            .start(element, Object.assign({ duration: defaultDuration }, options));
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgMicroInteractDirective {
    /**
     * @param {?} el
     * @param {?} renderer
     */
    constructor(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        this.type = 'fade';
        this.trigger = 'mouseover';
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.registerEventListeners();
    }
    /**
     * @return {?}
     */
    registerEventListeners() {
        this.renderer.listen(this.el.nativeElement, this.trigger, (/**
         * @return {?}
         */
        () => {
            NgMicroInteractFactory.setInteraction(this.type, this.el, this.options);
        }));
    }
}
NgMicroInteractDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngMicroInteract]'
            },] }
];
/** @nocollapse */
NgMicroInteractDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: Renderer2 }
];
NgMicroInteractDirective.propDecorators = {
    type: [{ type: Input }],
    trigger: [{ type: Input }],
    options: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NgMicroInteractDirective.prototype.type;
    /** @type {?} */
    NgMicroInteractDirective.prototype.trigger;
    /** @type {?} */
    NgMicroInteractDirective.prototype.options;
    /**
     * @type {?}
     * @private
     */
    NgMicroInteractDirective.prototype.el;
    /**
     * @type {?}
     * @private
     */
    NgMicroInteractDirective.prototype.renderer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgMicroInteractModule {
}
NgMicroInteractModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgMicroInteractDirective],
                imports: [],
                exports: [NgMicroInteractDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgMicroInteractDirective, NgMicroInteractModule };
//# sourceMappingURL=ng-micro-interact.js.map
